import netscape.application.*;
import netscape.util.*;

// An Application with a two-branch view hierarchy
public class Colors2 extends Application{
  ColorView green,orange,pink,yellow;
  
  public void init(){
    mainRootView().setColor(Color.black);

    int w = mainRootView().bounds().width;
    int h = mainRootView().bounds().height;

    // create four ColorViews.
    green = new ColorView(0,0,w/2,h/2,Color.green);
    orange = new ColorView(w/2,h/2,w/2,h/2,Color.orange);
    pink = new ColorView(0,0,w/4,h/4,Color.pink);
    yellow = new ColorView(0,h/4,w/4,h/4,Color.yellow);

    // add them to the view hierarchy
    mainRootView().addSubview(green);
    mainRootView().addSubview(orange);
    orange.addSubview(pink);
    orange.addSubview(yellow);   
  }
}
// a view subclass that draws itself with a solid color
class ColorView extends View{
  Color color;
  
  // The arguments to the constructor are:
  // x position, y position, width, height, color
  public ColorView(int x,int y,int w,int h,Color c){
    super(x,y,w,h);
    color = c;
  }
  
  public void drawView(Graphics g){
    g.setColor(color);
    g.fillRect(0,0,bounds.width,bounds.height);
  }
}
