import netscape.application.*;
import netscape.util.*;

// An application with a realistic view hierachy
public class GUIHierarchy extends Application{
  int wMid,hMid;
  // ContainerView, Button, Slider, and TextField all extend View,
  // so we can add them to the view hierarchy
  ContainerView guiContainer;
  ContainerView radioContainer,sliderContainer,popContainer;
  Button radio1,radio2,button;
  Slider slider;
  TextField textField;
  
  public void init(){
    mainRootView().setColor(Color.lightGray);
      
    wMid = mainRootView().bounds().width/2;
    hMid = mainRootView().bounds().height/2;
      
    // create a number of views and add them
    // to the view hierarchy.
    guiContainer = new ContainerView(mainRootView().bounds());
    guiContainer.setTitle("GUI Hierarchy");
      
    radioContainer = new ContainerView(0,15,wMid,hMid-15);
    radioContainer.setTitle("Radio Buttons");
    radio1 = Button.createRadioButton(wMid/3,(hMid-15)/2,15,15);
    radio2 = Button.createRadioButton(2*wMid/3,(hMid-15)/2,15,15);
    radioContainer.addSubview(radio1);
    radioContainer.addSubview(radio2);
      
    textField = new TextField(10,hMid+10,2*wMid-20,hMid-20);
    textField.setStringValue("A TextField");
  
    sliderContainer = new ContainerView(wMid,15,wMid,hMid-15);
    slider = new Slider(10,(hMid-15)/3,wMid-20,20);
    button = new Button(10,2*(hMid-15)/3,wMid-20,20);
    button.setTitle("A button");
    sliderContainer.addSubview(slider);
    sliderContainer.addSubview(button);

    mainRootView().addSubview(guiContainer);
    guiContainer.addSubview(radioContainer);
    guiContainer.addSubview(textField);
    guiContainer.addSubview(sliderContainer);     
  }
}
