import netscape.application.*;
import netscape.util.*;

public class TargetTest2 extends Application{
  Button addButton,clearButton;
  TargetField tField;
  
  public void init(){
      mainRootView().setColor(Color.green);

      Rect r = mainRootView().bounds;
      tField = new TargetField(0,r.height/2,r.width,r.height/2);
      mainRootView().addSubview(tField);
  
      // create a button
      addButton = new Button(10,10,80,30);
      addButton.setTitle("Press me");
      addButton.setCommand("addOne");  // set its command
      addButton.setTarget(tField);     // set its target
      mainRootView().addSubview(addButton);

      // create another button
      clearButton = new Button(100,10,80,30);
      clearButton.setTitle("Clear");
      clearButton.setCommand("clear");  // set its command
      clearButton.setTarget(tField);    // set its target
      mainRootView().addSubview(clearButton);
    }
}
      
// TargetField is a TextField subclass that can handle
// the two commands, "addOne" and "clear".
class TargetField extends TextField implements Target{
  int pressnumber = 0;

  public TargetField(int x,int y,int w,int h){
    super(x,y,w,h);
    setTransparent(true);
    setJustification(Graphics.CENTERED);
    setEditable(false);
    setBuffered(true);
  }

  // we must define this because TargetField implements Target
  public void performCommand(String command,Object data){
    if(command.equals("addOne")) addOne();
    else if(command.equals("clear")) clear();
    else super.performCommand(command,data);
  }
  
  // add one to pressnumber and redraw
  private void addOne(){
    pressnumber++;
    setStringValue("The button has been pressed " + pressnumber + " times.");
    setDirty(true);
  }

  // set pressnumber to zero and redraw
  private void clear(){
    pressnumber = 0;
    setStringValue("");
    setDirty(true);
  }
}
