import netscape.application.*;
import netscape.util.*;

public class Form extends Application{
  InfoInput infoInput;

  public void init(){
    infoInput = new InfoInput(mainRootView().localBounds());
    mainRootView().addSubview(infoInput);
  }
}

class InfoInput extends View implements TextFieldOwner,TextFilter{
  TextField nameField,empNumberField,passField;
  Label nameLabel,numberLabel,passLabel;

  public InfoInput(Rect r){
    this(r.x,r.y,r.width,r.height);
  }
  public InfoInput(int x, int y, int w, int h){
    super(x,y,w,h);
    int fieldHeight = 30;    // TextField height
    int fieldWidth = w-20;   // TextField width
    int spacing = 10;        // spacing between TextFields

    // create the "Employee Name" label and associated TextField
    nameLabel = new Label("Employee Name:",Font.defaultFont());
    nameLabel.moveTo(spacing,fieldHeight + 2*spacing - nameLabel.height());

    nameField = new TextField(spacing,fieldHeight+2*spacing,
			 fieldWidth,fieldHeight);
    
    // create the "Employee Number" label and associated TextField
    numberLabel = new Label("Employee Number:",Font.defaultFont());
    numberLabel.moveTo(spacing,3*fieldHeight+4*spacing-numberLabel.height());
	   
    empNumberField = new TextField(spacing,3*fieldHeight+4*spacing,
			 fieldWidth,fieldHeight);

    // create the "Password" label and associated TextField
    passLabel = new Label("Password:",Font.defaultFont());
    passLabel.moveTo(spacing,5*fieldHeight+6*spacing-passLabel.height());
   
    passField = new TextField(spacing,5*fieldHeight+6*spacing,
			 fieldWidth,fieldHeight);

    // set the tab fields
    nameField.setTabField(empNumberField);
    empNumberField.setTabField(passField);

    // set owners
    nameField.setOwner(this);
    empNumberField.setOwner(this);
    passField.setOwner(this);
    // filter the employee number field to allow only integers
    empNumberField.setFilter(this);
    // set * as the echo character
    passField.setDrawableCharacter('*');

    addSubview(nameLabel);
    addSubview(nameField);
    addSubview(numberLabel);
    addSubview(empNumberField);
    addSubview(passLabel);
    addSubview(passField);

  }

  // TextFieldOwner methods.
  // check for valid input before allowing editing to end.
  public boolean textEditingWillEnd(TextField tf,int why,boolean altered){
    if(tf==nameField){
      // check for valid name here...
    }
    else if(tf==empNumberField){
      // check employee number validity here...
    }
    else if(tf==passField){
      // check validity of the password here...
    }
    return true;
  }
  public void textEditingDidBegin(TextField tf){}
  public void textEditingDidEnd(TextField tf,int why,boolean altered){}
  public void textWasModified(TextField tf){}

  // TextFilter method.  Allows only integers in empNumberField
  public boolean acceptsEvent(Object tf,KeyEvent keyEvent,Vector eventVector){
    if(tf==empNumberField){
      // let the tab and return keys pass through unmodified
      if((char) keyEvent.key == '\t' ||
         (char) keyEvent.key == '\n') return true;
      // otherwise, only let integers appear
      if((char) keyEvent.key < '0' || (char) keyEvent.key > '9'){
	return false;
      }
    }
    return true;
  }
}
