import netscape.application.*;
import netscape.util.*;

// A ScrollGroup + ListView example
public class ScrollGroupExample2 extends Application implements Target{
  ListView listView;
  ScrollGroup listGroup;

  public void init(){
    // set up the listView
    setupListView();
    
    // create a ScrollGroup
    listGroup = new ScrollGroup();
    listGroup.setHasVertScrollBar(true);
    listGroup.setBounds(20,20,
          listView.width() + listGroup.minSize().width,150);

    // add the listView as the ScrollGroup's content view.
    listGroup.setContentView(listView);
    
    mainRootView().setBuffered(true);
    mainRootView().addSubview(listGroup);
  }

  private void setupListView(){
    listView = new ListView();
    listView.setTarget(this);
    ListItem item;
    for(int j=0;j<=255;j+=5){
      item = listView.addItem();
      item.setCommand(Integer.toString(j));
      item.setTitle(Integer.toString(j));
    }

    // size the listView to its minimum size
    listView.sizeTo(listView.minItemWidth(),listView.minSize().height);
  }

  public void performCommand(String command, Object data){
    try{
      int j = Integer.parseInt(command);
      mainRootView().setColor(new Color(j,j,j));
      mainRootView().setDirty(true);
    }
    catch(NumberFormatException e){}	
  }
}
