import netscape.application.*;
import netscape.util.*;

public class ScrollLabels extends Application implements Scrollable{
  ScrollBar sBar;
  int position = -122; // position of the content view.  Note the sign.
  TextField upperLabel,lowerLabel;
 
  public void init(){
      Rect rect = mainRootView().bounds();

      upperLabel = TextField.createLabel("Postion = " + position + "   ");
      upperLabel.moveTo(rect.width/2-30,60);
      lowerLabel = TextField.createLabel("ScrollPercent = 0.500000  ");
      lowerLabel.moveTo(rect.width/2-30,120);

      sBar = new ScrollBar(10,10,rect.width-20,20,Scrollable.HORIZONTAL);
      sBar.setScrollableObject(this);
      sBar.setScrollPercent((float) 0.5);

      mainRootView().setBuffered(true);
      mainRootView().addSubview(sBar); 
      mainRootView().addSubview(upperLabel); 
      mainRootView().addSubview(lowerLabel); 
     
  }

  public int lengthOfScrollViewForAxis(int axis){
      if(axis == Scrollable.HORIZONTAL) return 10;
      else return 0;  // vertical axis not used in this application
  }

  public int lengthOfContentViewForAxis(int axis){
      if(axis == Scrollable.HORIZONTAL)  return 255;
      else return 0;  // vertical axis not used in this application
  }
  
  public int positionOfContentViewForAxis(int axis){
      if(axis == Scrollable.HORIZONTAL) return position;
      else return 0;   // vertical axis not used in this application
  }

  public void scrollTo(int x, int y){
    position = x;

    // Don't let position get larger than its maximum value
    if(position > 0) position = 0;

    // Don't let position get smaller than its minimum value
    int length = lengthOfContentViewForAxis(Scrollable.HORIZONTAL) -
      lengthOfScrollViewForAxis(Scrollable.HORIZONTAL); 
    if(position < -length) position = -length;

    // redraw the the scroll bar
    sBar.performCommand(ScrollBar.UPDATE,this);
    
    // change the labels.  They are redrawn automatically.
    upperLabel.setStringValue("Position = " + position + " ");
    lowerLabel.setStringValue("ScrollPercent = " + sBar.scrollPercent() + " ");    
  }

  public void scrollBy(int x,int y){ scrollTo(position + x,y);}
}
