import netscape.application.*;
import netscape.util.*;

// an object that acts like a dropdown menu
public class TextPop extends View implements Target,TextFieldOwner{
  Target target;
  TextField textField;
  Popup popup;
  ContainerView container;

  public TextPop(int x,int y,int w,int h){
    super(x,y,w,h);
    setBuffered(true);
    // put the whole works in a ContainerView
    container = new ContainerView(localBounds());
    
    // a Popup menu
    popup = new Popup(5,5,(w-10)/3,h-10);
    popup.setTarget(this);

    // a TextField
    textField = new TextField(5+2*(w-10)/3,5,(w-10)/3,h-10);
    textField.setOwner(this);

    addSubview(container);
    container.addSubview(textField);
    container.addSubview(popup);
  }

  // allow the user to set the TextPop's target
  public void setTarget(Target t){
    target = t;
  }

  // notify the target if a valid command has been selected
  public void performCommand(String command,Object arg){
    for(int j = 0;j<popup.count();j++){
      ListItem item = popup.itemAt(j);
      if(command.equals(item.command())){
        textField.setStringValue(item.title());
        draw();
        target.performCommand(item.command(),item.data());
      }
    }
  }
  
  // give public access to the popup so items can be added to it
  public Popup popup(){ return popup;}

  // TextFieldOwner methods.
  // We only care if editing will end.
  public boolean textEditingWillEnd(TextField t,int reason,boolean altered){
    for(int j = 0;j<popup.count();j++){
      ListItem item = popup.itemAt(j);
      // if the entered string matches a command, inform the target
      if(t.stringValue().equals(item.command())){
        popup.selectItem(item);
        draw();
        target.performCommand(item.command(),item.data()); 
        return true;
      }
    }
    // invalid string, ignore it.
    textField.setStringValue(popup.selectedItem().title());
    return false;
  }

  public void textEditingDidEnd(TextField t,int reason,boolean altered){}
  public void textWasModified(TextField t){}
  public void textEditingDidBegin(TextField t){}
}
