import netscape.application.*;
import netscape.util.*;

// A layout manager example
public class Layouts extends Application{
  GridLayout layout,mainLayout;
  PackLayout packLayout;
  Button button1,button2,button3;
  TextField label1,label2,label3,label4,textfield;
  PackConstraints button1Constraints,button2Constraints;
  PackConstraints button3Constraints,textfieldConstraints;

  ContainerView cview,cview2;
  
  public void init(){
    // create the Container Views.
    // the sizes used here are totally irrelevant.
    // all views are resized by the LayoutManagers
    int w = mainRootView().bounds().width/2;
    int h = mainRootView().bounds().height/2;

    // cview covers the upper half of the RootView 
    // and contains four TextFieldss in a 2x2 GridLayout
    cview = new ContainerView(0,0,2*w,h);

    // cview2 covers the lower half of the RootView
    // and contains four Views positioned by a PackLayout
    cview2 = new ContainerView(0,h,2*w,h);
    mainRootView().addSubview(cview);
    mainRootView().addSubview(cview2);
    
    // create and set the layout managers
    layout = new GridLayout(2,2);  // cview's layout manager
    cview.setLayoutManager(layout);
    packLayout = new PackLayout();  // cview2's layout manager
    cview2.setLayoutManager(packLayout);
    mainLayout = new GridLayout(2,1);  // the RootView's layout manager
    mainRootView().setLayoutManager(mainLayout);
    
    // create subviews for cview1.
    // These will be positioned by a 2x2 GridLayout.
    label1 = createCenteredLabel("Label 1");
    label2 = createCenteredLabel("Label 2");
    label3 = createCenteredLabel("Label 3");
    label4 = createCenteredLabel("Label 4");

    // note:  *order* matters, not the initial bounds rects.
    cview.addSubview(label1);
    cview.addSubview(label2);
    cview.addSubview(label3);
    cview.addSubview(label4);
    
    // create subviews for cview2.
    // These will be positioned by a PackLayout.
    button1 = new Button(0,0,40,40);
    button1.setTitle("button 1");
    button2 = new Button(0,0,40,40);
    button2.setTitle("button 2");
    button3 = new Button(0,0,30,30);
    button3.setTitle("button 3");
    textfield = new TextField(0,10,100,40);
    
    // set the properties for cview2's subviews.
    // Remember, the order is anchor, expand, fillx, filly,
    // ipadx, ipady, padx, pady, and side.
    button1Constraints = new PackConstraints(PackConstraints.ANCHOR_NORTHWEST,
					   false,false,false,0,0,10,10,PackConstraints.SIDE_LEFT);
    button2Constraints = new PackConstraints(PackConstraints.ANCHOR_NORTHEAST,
					   false,false,false,0,0,10,10,PackConstraints.SIDE_RIGHT);
    button3Constraints = new PackConstraints(PackConstraints.ANCHOR_CENTER,
					 false,false,false,0,0,10,40,PackConstraints.SIDE_TOP);
    textfieldConstraints = new PackConstraints(PackConstraints.ANCHOR_SOUTH,
					    false,true,false,0,0,10,10,PackConstraints.SIDE_BOTTOM);
    // textfieldConstraints fills in the X direction
    
    packLayout.setConstraints(button1,button1Constraints);
    packLayout.setConstraints(button2,button2Constraints);
    packLayout.setConstraints(button3,button3Constraints);
    packLayout.setConstraints(textfield,textfieldConstraints);
    
    // add subviews to cview2
    cview2.addSubview(button1);
    cview2.addSubview(button2);
    cview2.addSubview(button3);
    cview2.addSubview(textfield);
    
    // force the layout managers to lay out their views
    cview2.layoutView(0,0);
    cview.layoutView(0,0);
    mainRootView().layoutView(0,0);      
  }

  // creates a label with a LineBorder and a centered message
  protected TextField createCenteredLabel(String message){
    TextField tf = new TextField();
    tf.setStringValue(message);
    tf.setEditable(false);
    tf.setTransparent(true);
    tf.setBorder(new LineBorder(Color.black));
    tf.setJustification(Graphics.CENTERED);
    return tf;
  }
}
