import netscape.application.*;
import netscape.util.*;

// demonstrates the 3 IFC "chooser" dialog boxes
public class Choosers extends Application implements ExtendedTarget{
  FileChooser filechooser;
  ColorChooser colorchooser;
  FontChooser fontchooser;
  InternalWindow colorwindow,fontwindow;
  Label label;

  public void init(){
    // create and show a FileChooser
    filechooser = new FileChooser(mainRootView(),
              "Press Cancel to Dismiss",FileChooser.LOAD_TYPE);
    filechooser.showModally();
    // create a label and display the chosen file's name
    label = new Label("You chose the file " + filechooser.file(),Font.defaultFont());
    label.moveTo(0,0);
    mainRootView().addSubview(label);

    // Use RootView methods to show a
    // ColorChooser and a FontChooser
    
    mainRootView().showColorChooser();
    mainRootView().showFontChooser();
  }

  public void performCommand(String command, Object arg){
    if(command.equals(ExtendedTarget.SET_FONT)){
      Font font = (Font) arg;
      // remove the old label
      label.removeFromSuperview();
      mainRootView().addDirtyRect(label.bounds());
      // make a new one with the new font
      label = new Label("You set the font to " + font.name(),
                   font);
      label.moveTo(0,0);
      // add it to the view hierarchy and draw it
      mainRootView().addSubview(label);
      mainRootView().addDirtyRect(label.bounds());
    }
  }
  
  // ExtendedTarget method
  public boolean canPerformCommand(String command){
    // handle the FontChooser's command
    if(command.equals("setFont")) return true;
    else return false;
  }
}
