import netscape.application.*;
import netscape.util.*;

public class OptionView extends View implements Target{
  RGBView rgb;
  Button clear,thick,thin,setOptions;
  ContainerView lineWidthContainer,buttonContainer;
  Target target;

  public OptionView(){
    super(0,0,220,260);  // hard code the size.

    setBuffered(true);  // looks better
    // Put everything in one big ContainerView.  This makes
    // the background a uniform color.
    ContainerView overallContainer = new ContainerView(localBounds());
    overallContainer.setBorder(null);
   
    // A ContainerView for the line width radio buttons.
    lineWidthContainer = new ContainerView(0,0,width(),60);
    lineWidthContainer.setTitle("Line Width");
    // The title is a subview, and thus if you use a LayoutManager
    // with a ContainerView with a title, it doesn't look right.
    // A separate ContainerView for the radio buttons.
    // Use a GridLayout to position the buttons.
    ContainerView radioContainer = new ContainerView(0,14,width(),42);
    radioContainer.setBorder(null);
    GridLayout gridLayout = new GridLayout(1,2);
    gridLayout.setHorizGap(10);
    radioContainer.setLayoutManager(gridLayout);
    lineWidthContainer.addSubview(radioContainer);
    // create the thin line and thick line buttons
    thick = Button.createRadioButton(1,1,1,1);
    thick.setTitle("Thick Lines");
    thin = Button.createRadioButton(1,1,1,1);
    thin.setTitle("Thin Lines");
    // add the buttons and lay out the view
    radioContainer.addSubview(thin);
    radioContainer.addSubview(thick);
    gridLayout.layoutView(radioContainer,0,0);

    // Another ContainerView for the RGBView
    ContainerView colorContainer = new ContainerView(0,
                  lineWidthContainer.height()+10,width(),145);
    colorContainer.setTitle("Line Color");
    rgb = new RGBView(2,14,width()-4,colorContainer.height()-16);
    colorContainer.addSubview(rgb);
 
    // A ContainerView for the "Clear All" and "Set Options" buttons.
    ContainerView buttonContainer = 
          new ContainerView(0,colorContainer.y()
                 +colorContainer.height()+10,width(),35);
    // Use a GridLayout again.
    GridLayout gridLayout2 = new GridLayout(1,2);
    buttonContainer.setBorder(null);
    buttonContainer.setLayoutManager(gridLayout2);
    gridLayout2.setVertGap(5);
    gridLayout2.setHorizGap(5);
    // create the buttons
    clear = new Button();
    clear.setTitle("Clear Drawing");
    clear.setCommand("clearAll");
    clear.setTarget(this);
    setOptions = new Button();
    setOptions.setTitle("Set Options");
    setOptions.setCommand("setOptions");
    setOptions.setTarget(this);
    // add the buttons and lay out the view
    buttonContainer.addSubview(clear);
    buttonContainer.addSubview(setOptions);
    gridLayout2.layoutView(buttonContainer,0,0);

    // add the container views to the view hierarchy
    overallContainer.addSubview(buttonContainer);
    overallContainer.addSubview(colorContainer);
    overallContainer.addSubview(lineWidthContainer);

    addSubview(overallContainer);
  }

  public void performCommand(String command,Object arg){
    if(command.equals("clearAll")){
      if(TargetChain.applicationChain().canPerformCommand("clearAll")){
        TargetChain.applicationChain().performCommand("clearAll",null);
      }
    }
    if(command.equals("setOptions")){
      Parameters params = new Parameters(rgb.color(),thick.state());
      if(TargetChain.applicationChain().canPerformCommand("setOptions")){
        TargetChain.applicationChain().performCommand(
                     "setOptions",params);
      }
    }
  }
}

