import netscape.application.*;
import netscape.util.*;

public class Scribbler extends Application implements Target{
  InternalOptionDialog optionDialog;
  InternalInfoDialog infoDialog;
  Menu menuBar;
  MenuItem fileItem,optionItem,aboutItem,infoItem,newScribbler;
  InternalWindow scribbleWindow;

  public void init(){
    // create a window to scribble in
    scribbleWindow = new ScribbleWindow();
    scribbleWindow.show();

    // create and add the menu
    menuBar = new Menu(true);
    fileItem = menuBar.addItemWithSubmenu("File");
    optionItem = fileItem.submenu().addItem("Options","options",this);
    newScribbler = fileItem.submenu().addItem("New Scribbler",
           "newScribbler",this);
    infoItem = menuBar.addItemWithSubmenu("Help"); 
    aboutItem = infoItem.submenu().addItem("About","about",this);
    if(mainRootView().externalWindow() != null)
      mainRootView().externalWindow().setMenu(menuBar);
  }

  public void performCommand(String command, Object data){
    if(command.equals("options")) onOptions();
    if(command.equals("about")) onAbout();
    if(command.equals("newScribbler")) createNewScribbler();
  }

  // create the drawing options dialog box
  protected void onOptions(){
    if(optionDialog != null && !optionDialog.isVisible()){
      optionDialog.moveTo(100,100);
      optionDialog.show();
    }
    if(optionDialog == null){
      optionDialog = new InternalOptionDialog();
      optionDialog.moveTo(100,100);
      optionDialog.show();
    }
  }

  // create a new information dialog box
  protected void onAbout(){
    if(infoDialog != null && !infoDialog.isVisible()){
      infoDialog.moveTo(100,100);
      infoDialog.show();
    }
    if(infoDialog == null){
      infoDialog = new InternalInfoDialog(Alert.notificationImage(),
		   "Scribbler","By Dean Petrich, 1997.","OK");
      infoDialog.moveTo(100,100);
      infoDialog.show();
    }
  }
  
  // create a new scribble window
  protected void createNewScribbler(){
    ScribbleWindow newWindow = new ScribbleWindow();
    newWindow.show();
  }

}



