import netscape.application.*;
import netscape.util.*;
import java.io.*;

// an application that reads the archive from Example 21-1.
public class ArchiveReader extends Application{
  Archive archive;
  FileInputStream archiveInputStream;
  View view;
  
  public void init(){
    archive = new Archive();
    
    try{archiveInputStream = new FileInputStream("ASCIIArchive");}
    catch(IOException e) {showExceptionInfo(e);}
    
    try{archive.readASCII(archiveInputStream);}
    catch(CodingException e) {showExceptionInfo(e);}
    catch(IOException e) {showExceptionInfo(e);}
    catch(DeserializationException e) {showExceptionInfo(e);}
    
    /*
    try{archiveInputStream = new FileInputStream("BinaryArchive");}
    catch(IOException e) {showExceptionInfo(e);}
    
    try{archive.read(archiveInputStream);}
    catch(IOException e) {showExceptionInfo(e);}
    */

    int[] rootIdentifiers = archive.rootIdentifiers();
    Unarchiver unarchiver = new Unarchiver(archive);
    
    try{view = 
      (View) unarchiver.unarchiveIdentifier(rootIdentifiers[0]);
    }
    catch(CodingException e) {showExceptionInfo(e);}
    
    mainRootView().addSubview(view);
  }
  
  private void showExceptionInfo(Exception e){
    System.out.println(e.getMessage());
    e.printStackTrace(System.out);
    System.exit(0);
  }
}
